using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using ZXDT.DBUtility;
using ZXDT.CallCenter.Model;
using System.Collections.Generic;
namespace ZXDT.CallCenter.DAL
{
	/// <summary>
	/// 数据访问类:T_RepositoryCategory
	/// </summary>
	public partial class T_RepositoryCategory
	{
		public T_RepositoryCategory()
		{}
		#region  BasicMethod

		/// <summary>
		/// 得到最大ID
		/// </summary>
		public int GetMaxId()
		{
		return DbHelperSQL.GetMaxID("F_CategoryId", "T_RepositoryCategory"); 
		}

		/// <summary>
		/// 是否存在该记录
		/// </summary>
		public bool Exists(int F_CategoryId)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select count(1) from T_RepositoryCategory");
			strSql.Append(" where F_CategoryId=@F_CategoryId");
			SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
			};
			parameters[0].Value = F_CategoryId;

			return DbHelperSQL.Exists(strSql.ToString(),parameters);
		}


		/// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(ZXDT.CallCenter.Model.T_RepositoryCategory model)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("insert into T_RepositoryCategory(");
			strSql.Append("F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag,F_IsOrPrivate)");
			strSql.Append(" values (");
			strSql.Append("@F_CategoryNumber,@F_CategoryName,@F_CategoryEName,@F_Layer,@F_ParentId,@F_CategoryType,@F_CanDelete,@F_IsCommon,@F_Sort,@F_Expand1,@F_Expand2,@F_CreateOn,@F_CreateBy,@F_DeleteFlag,@F_IsOrPrivate)");
			strSql.Append(";select @@IDENTITY");
			SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryNumber", SqlDbType.NVarChar,200),
					new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CategoryEName", SqlDbType.NVarChar,200),
					new SqlParameter("@F_Layer", SqlDbType.Int,4),
					new SqlParameter("@F_ParentId", SqlDbType.Int,4),
					new SqlParameter("@F_CategoryType", SqlDbType.SmallInt,2),
					new SqlParameter("@F_CanDelete", SqlDbType.SmallInt,2),
					new SqlParameter("@F_IsCommon", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Expand1", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Expand2", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
					new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
					new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2),
            new SqlParameter("@F_IsOrPrivate", SqlDbType.Int,4)};
			parameters[0].Value = model.F_CategoryNumber;
			parameters[1].Value = model.F_CategoryName;
			parameters[2].Value = model.F_CategoryEName;
			parameters[3].Value = model.F_Layer;
			parameters[4].Value = model.F_ParentId;
			parameters[5].Value = model.F_CategoryType;
			parameters[6].Value = model.F_CanDelete;
			parameters[7].Value = model.F_IsCommon;
			parameters[8].Value = model.F_Sort;
			parameters[9].Value = model.F_Expand1;
			parameters[10].Value = model.F_Expand2;
			parameters[11].Value = model.F_CreateOn;
			parameters[12].Value = model.F_CreateBy;
			parameters[13].Value = model.F_DeleteFlag;
            parameters[14].Value = model.F_IsOrPrivate;
            object obj = DbHelperSQL.GetSingle(strSql.ToString(),parameters);
			if (obj == null)
			{
				return 0;
			}
			else
			{
				return Convert.ToInt32(obj);
			}
		}
		/// <summary>
		/// 更新一条数据
		/// </summary>
		public bool Update(ZXDT.CallCenter.Model.T_RepositoryCategory model)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("update T_RepositoryCategory set ");
			strSql.Append("F_CategoryNumber=@F_CategoryNumber,");
			strSql.Append("F_CategoryName=@F_CategoryName,");
			strSql.Append("F_CategoryEName=@F_CategoryEName,");
			strSql.Append("F_Layer=@F_Layer,");
			strSql.Append("F_ParentId=@F_ParentId,");
			strSql.Append("F_CategoryType=@F_CategoryType,");
			strSql.Append("F_CanDelete=@F_CanDelete,");
			strSql.Append("F_IsCommon=@F_IsCommon,");
			strSql.Append("F_Sort=@F_Sort,");
			strSql.Append("F_Expand1=@F_Expand1,");
			strSql.Append("F_Expand2=@F_Expand2,");
			strSql.Append("F_CreateOn=@F_CreateOn,");
			strSql.Append("F_CreateBy=@F_CreateBy,");
			strSql.Append("F_DeleteFlag=@F_DeleteFlag,");
            strSql.Append("F_IsOrPrivate=@F_IsOrPrivate");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
			SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryNumber", SqlDbType.NVarChar,200),
					new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CategoryEName", SqlDbType.NVarChar,200),
					new SqlParameter("@F_Layer", SqlDbType.Int,4),
					new SqlParameter("@F_ParentId", SqlDbType.Int,4),
					new SqlParameter("@F_CategoryType", SqlDbType.SmallInt,2),
					new SqlParameter("@F_CanDelete", SqlDbType.SmallInt,2),
					new SqlParameter("@F_IsCommon", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Expand1", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Expand2", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
					new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
					new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_IsOrPrivate", SqlDbType.Int,4),

                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
            };
			parameters[0].Value = model.F_CategoryNumber;
			parameters[1].Value = model.F_CategoryName;
			parameters[2].Value = model.F_CategoryEName;
			parameters[3].Value = model.F_Layer;
			parameters[4].Value = model.F_ParentId;
			parameters[5].Value = model.F_CategoryType;
			parameters[6].Value = model.F_CanDelete;
			parameters[7].Value = model.F_IsCommon;
			parameters[8].Value = model.F_Sort;
			parameters[9].Value = model.F_Expand1;
			parameters[10].Value = model.F_Expand2;
			parameters[11].Value = model.F_CreateOn;
			parameters[12].Value = model.F_CreateBy;
			parameters[13].Value = model.F_DeleteFlag;
            parameters[14].Value = model.F_IsOrPrivate;
            parameters[15].Value = model.F_CategoryId;

			int rows=DbHelperSQL.ExecuteSql(strSql.ToString(),parameters);
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		/// <summary>
		/// 删除一条数据
		/// </summary>
		public bool Delete(int F_CategoryId)
		{
			
			StringBuilder strSql=new StringBuilder();
			//strSql.Append("delete from T_RepositoryCategory ");
            strSql.Append("update T_RepositoryCategory set F_DeleteFlag=1");
			strSql.Append(" where F_CategoryId=@F_CategoryId");
			SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
			};
			parameters[0].Value = F_CategoryId;

			int rows=DbHelperSQL.ExecuteSql(strSql.ToString(),parameters);
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		/// <summary>
		/// 批量删除数据
		/// </summary>
		public bool DeleteList(string F_CategoryIdlist )
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("delete from T_RepositoryCategory ");
			strSql.Append(" where F_CategoryId in ("+F_CategoryIdlist + ")  ");
			int rows=DbHelperSQL.ExecuteSql(strSql.ToString());
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}


		/// <summary>
		/// 得到一个对象实体
		/// </summary>
		public ZXDT.CallCenter.Model.T_RepositoryCategory GetModel(int F_CategoryId)
		{
			
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select  top 1 F_CategoryId,F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag,F_IsOrPrivate from T_RepositoryCategory ");
			strSql.Append(" where F_CategoryId=@F_CategoryId");
			SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
			};
			parameters[0].Value = F_CategoryId;

			ZXDT.CallCenter.Model.T_RepositoryCategory model=new ZXDT.CallCenter.Model.T_RepositoryCategory();
			DataSet ds=DbHelperSQL.Query(strSql.ToString(),parameters);
			if(ds.Tables[0].Rows.Count>0)
			{
				return DataRowToModel(ds.Tables[0].Rows[0]);
			}
			else
			{
				return null;
			}
		}


		/// <summary>
		/// 得到一个对象实体
		/// </summary>
		public ZXDT.CallCenter.Model.T_RepositoryCategory DataRowToModel(DataRow row)
		{
			ZXDT.CallCenter.Model.T_RepositoryCategory model=new ZXDT.CallCenter.Model.T_RepositoryCategory();
			if (row != null)
			{
				if(row["F_CategoryId"]!=null && row["F_CategoryId"].ToString()!="")
				{
					model.F_CategoryId=int.Parse(row["F_CategoryId"].ToString());
				}
				if(row["F_CategoryNumber"]!=null)
				{
					model.F_CategoryNumber=row["F_CategoryNumber"].ToString();
				}
				if(row["F_CategoryName"]!=null)
				{
					model.F_CategoryName=row["F_CategoryName"].ToString();
				}
				if(row["F_CategoryEName"]!=null)
				{
					model.F_CategoryEName=row["F_CategoryEName"].ToString();
				}
				if(row["F_Layer"]!=null && row["F_Layer"].ToString()!="")
				{
					model.F_Layer=int.Parse(row["F_Layer"].ToString());
				}
				if(row["F_ParentId"]!=null && row["F_ParentId"].ToString()!="")
				{
					model.F_ParentId=int.Parse(row["F_ParentId"].ToString());
				}
				if(row["F_CategoryType"]!=null && row["F_CategoryType"].ToString()!="")
				{
					model.F_CategoryType=int.Parse(row["F_CategoryType"].ToString());
				}
				if(row["F_CanDelete"]!=null && row["F_CanDelete"].ToString()!="")
				{
					model.F_CanDelete=int.Parse(row["F_CanDelete"].ToString());
				}
				if(row["F_IsCommon"]!=null && row["F_IsCommon"].ToString()!="")
				{
					model.F_IsCommon=int.Parse(row["F_IsCommon"].ToString());
				}
				if(row["F_Sort"]!=null && row["F_Sort"].ToString()!="")
				{
					model.F_Sort=int.Parse(row["F_Sort"].ToString());
				}
				if(row["F_Expand1"]!=null)
				{
					model.F_Expand1=row["F_Expand1"].ToString();
				}
				if(row["F_Expand2"]!=null)
				{
					model.F_Expand2=row["F_Expand2"].ToString();
				}
				if(row["F_CreateOn"]!=null && row["F_CreateOn"].ToString()!="")
				{
					model.F_CreateOn=DateTime.Parse(row["F_CreateOn"].ToString());
				}
				if(row["F_CreateBy"]!=null && row["F_CreateBy"].ToString()!="")
				{
					model.F_CreateBy=int.Parse(row["F_CreateBy"].ToString());
				}
				if(row["F_DeleteFlag"]!=null && row["F_DeleteFlag"].ToString()!="")
				{
					model.F_DeleteFlag=int.Parse(row["F_DeleteFlag"].ToString());
				}
                if (row["F_IsOrPrivate"] != null && row["F_IsOrPrivate"].ToString() != "")
                {
                    model.F_IsOrPrivate = int.Parse(row["F_IsOrPrivate"].ToString());
                }
            }
			return model;
		}

		/// <summary>
		/// 获得数据列表
		/// </summary>
		public DataSet GetList(string strWhere)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select F_CategoryId,F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag,F_IsOrPrivate ");
			strSql.Append(" FROM T_RepositoryCategory ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			return DbHelperSQL.Query(strSql.ToString());
		}

		/// <summary>
		/// 获得前几行数据
		/// </summary>
		public DataSet GetList(int Top,string strWhere,string filedOrder)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select ");
			if(Top>0)
			{
				strSql.Append(" top "+Top.ToString());
			}
			strSql.Append(" F_CategoryId,F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag,F_IsOrPrivate ");
			strSql.Append(" FROM T_RepositoryCategory ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			strSql.Append(" order by " + filedOrder);
			return DbHelperSQL.Query(strSql.ToString());
		}

		/// <summary>
		/// 获取记录总数
		/// </summary>
		public int GetRecordCount(string strWhere)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select count(1) FROM T_RepositoryCategory ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			object obj = DbHelperSQL.GetSingle(strSql.ToString());
			if (obj == null)
			{
				return 0;
			}
			else
			{
				return Convert.ToInt32(obj);
			}
		}
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("SELECT * FROM ( ");
			strSql.Append(" SELECT ROW_NUMBER() OVER (");
			if (!string.IsNullOrEmpty(orderby.Trim()))
			{
				strSql.Append("order by T." + orderby );
			}
			else
			{
				strSql.Append("order by T.F_CategoryId desc");
			}
			strSql.Append(")AS Row, T.*  from T_RepositoryCategory T ");
			if (!string.IsNullOrEmpty(strWhere.Trim()))
			{
				strSql.Append(" WHERE " + strWhere);
			}
			strSql.Append(" ) TT");
			strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
			return DbHelperSQL.Query(strSql.ToString());
		}

		/*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_RepositoryCategory";
			parameters[1].Value = "F_CategoryId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

		#endregion  BasicMethod
        #region 获取树结构
        /// <summary>
        ///  获得当前节点下的所有子集以tree的格式
        /// </summary>
        public TreeNodeModel GetRepositoryCategoryJsonModel(int parentId)
        {
            TreeNodeModel returnModel = new TreeNodeModel();
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_RepositoryCategory where    F_DeleteFlag=0  order by F_Sort asc");

            DataSet ds = DbHelperSQL.Query(strSql.ToString());

            if (ds != null && ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
            {
                DataRow[] rows = ds.Tables[0].Select("F_CategoryId=" + parentId);
                if (rows != null && rows.Length > 0)
                {
                    TreeNodeModel model = new TreeNodeModel();
                    List<TreeNodeModel> modelList = new List<TreeNodeModel>();
                    model.id = int.Parse(rows[0]["F_CategoryId"].ToString());
                    model.name = rows[0]["F_CategoryName"].ToString();
                    model.code = int.Parse(rows[0]["F_CategoryId"].ToString());
                    model.iconClose = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_close.png";
                    model.iconOpen = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_open.png";
                    model.open = "true";
                    model.children = modelList;
                    model.IsOrPrivate = rows[0]["F_IsOrPrivate"].ToInt32();
                    returnModel = GetTreeModel(ds.Tables[0], model);
                }
            }
            return returnModel;
        }


        /// <summary>
        /// 获取chlid
        /// </summary>
        /// <param name="table">数据结合</param>
        /// <param name="model">当前model</param>
        /// <returns></returns>
        public TreeNodeModel GetTreeModel(DataTable table, TreeNodeModel model)
        {
            DataRow[] rows = table.Select("F_ParentId=" + model.code);
            if (rows != null && rows.Length > 0)
            {
                foreach (DataRow row in rows)
                {
                    List<TreeNodeModel> modelList = new List<TreeNodeModel>();
                    TreeNodeModel childModel = new TreeNodeModel();
                    childModel.id = int.Parse(row["F_CategoryId"].ToString());
                    childModel.name = row["F_CategoryName"].ToString();
                    childModel.code = int.Parse(row["F_CategoryId"].ToString());
                    childModel.iconClose = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_close.png";
                    childModel.iconOpen = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_open.png";
                    childModel.open = "true";
                    childModel.children = modelList;
                    model.children.Add(childModel);
                    GetTreeModel(table, childModel);
                }
            }
            return model;

        }

        #endregion
	}
}

